#!/usr/bin/env python

import string


runcard={}

runcard['pdf_provider'] = 'MSTW'             # MSTW,MSTW_P,MSTW_M,MSTW90,MSTW90_P,MSTW_90_M, GJR, ABKM
runcard['effective_theory_flag'] ='0'       # 0: exact LO,NLO + effective NNLO, 1:effective theory LO,NLO,NNLO
runcard['no_error_flag'] = '1'               # 0: pdf error  ,   1 : NO pdf error
runcard['collider'] = 'LHC'                  # LHC, TEVATRON
runcard['Etot'] = '7000'                     # COM energy. If collider=TEVATRON, Etot is ignored (set to 1960 GeV)
runcard['mhiggs']= '120.0'
runcard['higgs_width_scheme']='0'
#runcard['higgs_width_grid = HWGrid/HdecayGrid.dat  # Setting a path for the grid of the Higgs width. If no path is set, the width is retrieved from the default grid, HdecayGrid.dat constructred from Hdecay
#runcard['min_mh=130.0                   # Setting a minimum in the virtuality of the Higgs. Idle, when DecayMode=no_width
#runcard['max_mh=140.0                   # Setting a maximum in the virtuality of the Higgs. Idle, when DecayMode=no_width

runcard['muf/mhiggs'] = '0.5'
runcard['mur/mhiggs'] = '0.5'
runcard['DecayMode'] = 'total'               # no_width,total, gamma gamma, WW,ZZ,b b-bar
runcard['ProductionMode']='gg'                       # gg, bb
#
runcard['K_ewk']= '1.0'                     # rescaling factor for EWK corrections. Set it to 0.0 to switch them off
runcard['K_ewk_real']='1.0'                  #rescaling factor for real EWK corrections (to h+j). Set it to 0.0 to switch them off
runcard['K_ewk_real_b']='1.0'                #rescaling the corrections for massive quarks and Higgs in the ewk loop
#
#  quarks
#
runcard['m_top'] = '172.5'                   # default: 172.7
runcard['Gamma_top'] = '0.0'                 # default: 0
runcard['Y_top']= '1.0'                     # factor that multiplies SM Yukawa_top ( Yt > 0.0 )
                                # warning: one can set Yt as small as one wants, e.g. 1d-23 is fine, but NOT to 0.0
runcard['m_bot']= '3.63'                     # m_b @ 10 GeV
runcard['Gamma_bot'] = '0.0'                 # default : 0
runcard['Y_bot'] = '1.0'                     # factor that multiplies SM Yukawa_bottom
                                # extra quarks (e.g. 4th generation)
#heavy quark = 400.0 :0.0 :  1.0 # mass : width : yukawa
#heavy quark = 401.0 :0.0 : 1.0  # mass : width : yukawa
#heavy quark = 1000.0 :0.0 : 1.0  # mass : width : yukawa
#heavy quark = 6000.0 :0.0 : 1.0  # mass : width : yukawa
#heavy quark = 6000.0 :0.0 :  0.0  # mass : width : yukawa

#
# Vector bosons
#
runcard['m_Z'] = '91.1876'
runcard['Gamma_Z'] = '2.4952'
runcard['Y_Z'] = '1.0'
runcard['m_W'] = '80.403'
runcard['Gamma_W'] = '2.141'
runcard['Y_W']= '1.0'
#extra vector boson= 200.0 : 12.3 : 1.0 : 2.0 # mass : with : yukawa : type (1.0=W-like, 2.0=Z-like)
#extra vector boson = 330.0: 23.2 : 1.0 : 1.0
# integration (vegas) parameters
runcard['epsrel'] = '0.001'                  # target for relative error
runcard['epsabs'] = '0.000000001'            # target for absolute error
runcard['nstart'] = '10000'                  # number of points per iteration at start
runcard['nincrease'] = '1000'                        # increase step in the number of points per iteration
runcard['mineval'] = '0'                     # minimum number of evaluations before ending (even if accuracy targets are reached)
runcard['maxeval'] = '50000000'              # maximum number of evaluations (even if accuracy is NOT reached)
runcard['adapt to central only'] = '0'       # 0: adapt to all   1: adapt to central
                                # whether to have a preparatory Vegas run to adapt the grid
                                # involving only  the central PDF member set
runcard['vegas_verbose'] = '1'               # verbosity level for vegas output 0:silent 2:iteration information + chi squares


hwins={}
hwins[120]=[115.0,125.0]
hwins[165]=[160.0,170.0]
hwins[200]=[192.0,208.0]
hwins[400]=[366.0,434.0]
hwins[600]=[490.0,710.0]
hwins[800]=[500.0,1100.0]


dirname = 'sample_xsections_111/'

for mh in [120,165,200,400,600,800]:
      suffix = 'ZWA'
      runcard['DecayMode']='no_width'
      runcard['higgs_width_scheme']='0'
      filename=dirname+suffix+str(mh)
      f = open(filename, 'w')
      runcard['mhiggs']=str(mh)
      #runcard['min_mh']=str(hwins[mh][0])
      #runcard['max_mh']=str(hwins[mh][1])
      for item in sorted(runcard.keys()):
            print item,"=", runcard[item]
            line=item+'='+runcard[item]+'\n'
            f.write(line)
      f.close()


for mh in [120,165,200,400,600,800]:
      suffix = 'DEF'
      runcard['DecayMode']='total'
      runcard['higgs_width_scheme']='0'
      filename=dirname+suffix+str(mh)
      f = open(filename, 'w')
      runcard['mhiggs']=str(mh)
      #runcard['min_mh']=str(hwins[mh][0])
      #runcard['max_mh']=str(hwins[mh][1])
      for item in sorted(runcard.keys()):
            print item,"=", runcard[item]
            line=item+'='+runcard[item]+'\n'
            f.write(line)
      f.close()

for mh in [120,165,200,400,600,800]:
      suffix = 'DEF_W'
      runcard['DecayMode']='total'
      runcard['higgs_width_scheme']='0'
      filename=dirname+suffix+str(mh)
      f = open(filename, 'w')
      runcard['mhiggs']=str(mh)
      runcard['min_mh']=str(hwins[mh][0])
      runcard['max_mh']=str(hwins[mh][1])
      for item in sorted(runcard.keys()):
            print item,"=", runcard[item]
            line=item+'='+runcard[item]+'\n'
            f.write(line)
      f.close()

for mh in [120,165,200,400,600,800]:
      suffix = 'SEY'
      runcard['DecayMode']='total'
      runcard['higgs_width_scheme']='1'
      filename=dirname+suffix+str(mh)
      f = open(filename, 'w')
      runcard['mhiggs']=str(mh)
      #runcard['min_mh']=str(hwins[mh][0])
      #runcard['max_mh']=str(hwins[mh][1])
      for item in sorted(runcard.keys()):
            print item,"=", runcard[item]
            line=item+'='+runcard[item]+'\n'
            f.write(line)
      f.close()


for mh in [120,165,200,400,600,800]:
      suffix = 'SEY_W'
      runcard['DecayMode']='total'
      runcard['higgs_width_scheme']='1'
      filename=dirname+suffix+str(mh)
      f = open(filename, 'w')
      runcard['mhiggs']=str(mh)
      runcard['min_mh']=str(hwins[mh][0])
      runcard['max_mh']=str(hwins[mh][1])
      for item in sorted(runcard.keys()):
            print item,"=", runcard[item]
            line=item+'='+runcard[item]+'\n'
            f.write(line)
      f.close()






