      subroutine hggtotal(result,result_p,result_m,mcerror)
      implicit none 
	!
      double precision integral,error,prob
	integer ncomp,ndim
      integer idm
      parameter (idm=709)
      dimension integral(idm),error(idm),prob(idm)
      COMMON/results/integral,error,prob
      !
      double precision result(3),result_p(3),result_m(3),mcerror(3)  
	integer no_error_flag
	!
      character*60  porder
	!
      double precision qcd_lo_v, qcd_lo_p, qcd_lo_m
      double precision qcd_nlo_v, qcd_nlo_p, qcd_nlo_m
      double precision qcd_nnlo_v, qcd_nnlo_p, qcd_nnlo_m
      !: --  
      integer pset
      integer Ngrids
      !: necessary for muf
	double precision 	tau, Etot, muf,mur
	character*60 collider
	common /toHiggsF/ tau,Etot,muf,mur,collider
	!
	double precision mc_error_LO,mc_error_NLO,mc_error_NNLO
      external INTE2, INTE1, INTE0
	!: pdf variables
	character*40  pdfset_name(0:2)
	character*10 pdf_provider
	integer p_min_order
	common /comPDFsetup/ p_min_order,no_error_flag,
     $pdfset_name,pdf_provider
      !
	
	ndim=4
c
c     ************************ begining of pset loop  
c
	do pset = p_min_order,2            
            Ngrids=0
            if (pset.eq.0) then !LO
			porder = 'LO'
                  print*,' ' 
                  print*,'             * * *      '
                  print*,' '
                  print*,'QCD order : ',porder
			call init_pdfaserror(pdfset_name(pset),muf,
     #					no_error_flag,Ngrids)
			!Ngrids is set inside init_pdfaserror->pdf_fitter
			ncomp=Ngrids+1
			call evolve_as_yukawa(mur,porder,Ngrids)
			call prepare_bin_data()
			print*,'Starting Vegas integration'
                  call new_integrate(ndim,ncomp,INTE0)
			call write_bin_data(dsqrt(tau)*Etot,0)
			mc_error_LO=error(1)
			!error calculation
			call givevalerr(Ngrids,integral,qcd_lo_v,qcd_lo_p,
     &				qcd_lo_m,pdf_provider)
            endif
		if (pset.eq.1) then !NLO
			porder = 'NLO'
                  print*,' ' 
                  print*,'             * * *      '
                  print*,' '
                  print*,'QCD order : ',porder
			call init_pdfaserror(pdfset_name(pset),muf,
     #					no_error_flag,Ngrids)
			!Ngrids is set inside init_pdfaserror->pdf_fitter
			ncomp=Ngrids+1
			call evolve_as_yukawa(mur,porder,Ngrids)
                  call prepare_bin_data()
                  print*,'Starting Vegas integration'
                  call new_integrate(ndim,ncomp,INTE1)
                  call write_bin_data(dsqrt(tau)*Etot,1)
                  mc_error_NLO=error(1)
			!error calculation
			call givevalerr(Ngrids,integral,qcd_nlo_v,qcd_nlo_p,
     &				qcd_nlo_m,pdf_provider)          
            endif
		if (pset.eq.2) then !NNLO
			porder = 'NNLO'
                  print*,' ' 
                  print*,'             * * *      '
                  print*,' '
                  print*,'QCD order : ',porder
			call init_pdfaserror(pdfset_name(pset),muf,
     #					no_error_flag,Ngrids)
			!Ngrids is set inside init_pdfaserror->pdf_fitter
			ncomp=Ngrids+1
			call evolve_as_yukawa(mur,porder,Ngrids)
			call prepare_bin_data()                  
			print*,'Starting Vegas integration'
                  call new_integrate(ndim,ncomp,INTE2)
                  call write_bin_data(dsqrt(tau)*Etot,2)
                                 
			mc_error_NNLO=error(1)
			!error calculation
		      call givevalerr(Ngrids,integral,qcd_nnlo_v,qcd_nnlo_p,
     &				qcd_nnlo_m,pdf_provider)          
            endif

      enddo
c
c     ************************ end of pset loop  
c


c	storing the xsections, uncertainties and mc errors 
      result(1)=qcd_lo_v
      result(2)=qcd_nlo_v  
      result(3)=qcd_nnlo_v
      result_p(1)=qcd_lo_p
      result_p(2)=qcd_nlo_p  
      result_p(3)=qcd_nnlo_p
	result_m(1)=qcd_lo_m
      result_m(2)=qcd_nlo_m  
      result_m(3)=qcd_nnlo_m
	mcerror(1)=mc_error_LO
	mcerror(2)=mc_error_NLO
	mcerror(3)=mc_error_NNLO
      END


c====================================================

      subroutine prepare_bin_data()
      implicit none
      integer maxitno,iternumber,itno
      integer number_of_bins
      parameter (number_of_bins=1970)
	double precision my_bins(number_of_bins,200)
	common /cmybins/ my_bins,maxitno
	integer ibins
      !=== bindata prep
      do ibins=1,97
            do iternumber=1,200
                  my_bins(ibins,iternumber)=0d0
            enddo
      enddo
      !=== end of bindata prep
      end
c====================================================
      subroutine setbinfname(binfname_in,binflag_in)
      implicit none
      character*100 bin_fname,binfname_in
      integer binflag,binflag_in
      common /binfnamecom/ binflag
      
      binflag=binflag_in
      bin_fname=binfname_in
      end
c====================================================
      subroutine write_bin_data(mh,order)
      implicit none
      double precision mh
      integer order
      !
      integer maxitno,iternumber,itno
      integer number_of_bins
      parameter (number_of_bins=1970)
	double precision my_bins(number_of_bins,200)
	common /cmybins/ my_bins,maxitno
	integer ibins
     
      character*5 file_ext
      character*100 bin_fname,loc_binfname
      integer binflag
      common /binfnamecom/ binflag      
      integer mmh
      
      
      if (binflag.eq.1) then 
            mmh=mh
      
            write(file_ext,"(I3,A,I1)") mmh,".",order
            bin_fname = "masshisto"//file_ext

            loc_binfname = bin_fname//file_ext

            OPEN(1, FILE=loc_binfname)
            write(1,*),"number of iterations ",maxitno
            itno=maxitno
            do ibins=1,number_of_bins
			write(1,*),30d0+(ibins-1)*(2000d0-30d0)/number_of_bins
     $					,my_bins(ibins,itno)
		enddo
            close(1)
      
      print*,"Invariant mass distributions data written at ",
     $      loc_binfname
      endif
      end

c====================================================
	subroutine set_com_to_higgsf(tau_in, Etot_in,collider_in, 
     $				muf_in,mur_in,max_mh_in,min_mh_in)
	implicit none
	integer collider_in
	double precision 	tau_in, Etot_in, muf_in,mur_in
	!
	double precision 	tau, Etot, muf,mur,max_mh_in,min_mh_in
	character*60 collider
	common /toHiggsF/ tau,Etot,muf,mur,collider
      !
      double precision Qmin,Qmax
      common /mhWindow/ Qmin,Qmax
	!
	
      Qmin=max_mh_in
      Qmax=min_mh_in
      
	tau=tau_in
	Etot=Etot_in
	muf=muf_in
	mur=mur_in
	if (collider_in.eq.0) then 
            collider = "LHC"
      elseif (collider_in.eq.1) then
            collider = "TEVATRON"
      else
            print*,"NON RECOGNIZED COLLIDER ID : ",collider_in
      endif
	end
	
c====================================================
	subroutine set_vegas_input_variables(in_nstart,in_nincrease
     $,in_mineval,in_maxeval,
     $in_adjusting_phase_flag,in_epsrel,in_epsabs,in_verbose)
      implicit none
c	---- vegas input
	integer in_nstart,in_nincrease,in_mineval
	integer in_maxeval,in_adjusting_phase_flag
	double precision in_epsrel,in_epsabs
	integer nstart,nincrease,mineval,maxeval,adjusting_phase_flag
      integer verbose,in_verbose
	double precision epsrel,epsabs
	common/vegasinput/nstart,nincrease,epsrel,epsabs,
     &mineval,maxeval,adjusting_phase_flag,verbose

c	!Vegas input variables
	nstart = in_nstart
	nincrease = in_nincrease
	mineval = in_mineval
	maxeval = in_maxeval
	adjusting_phase_flag = in_adjusting_phase_flag
	epsrel = in_epsrel
	epsabs = in_epsabs
      verbose=in_verbose
	end
c====================================================
	subroutine set_common_flags(effective_theory_flag_in,K_ewk_in,
     $				K_ewk_real_in,K_ewk_real_b_in,
     $				ProductionMode_in)
	implicit none
	integer ProductionMode_in,effective_theory_flag_in
	double precision K_ewk_real_in,K_ewk_in,K_ewk_real_b_in
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c ------- 	
	!: K_ewk is a global rescaling factor for the EWK piece. 
	!It's set in runcard (default=1.0)
	double precision K_ewk
	common /commonKewk/ K_ewk
	!: K_ewk_real is a global rescaling factor for the EWK real piece:
	! corrections to (h+j) - see Petriello and Keung arXiv:0905.2775 [hep-ph]. 
	! It's set in runcard (default=1.0)
	!
	! rescaling factor for the massive quarks and higgs in the EW loop
	double precision K_ewk_real_b
	common /commonKewkrealb/ K_ewk_real_b
	!
	double precision K_ewk_real
	common /commonKewkreal/ K_ewk_real 
	!:common flags 
	integer ProductionMode
	common /commonflags/ ProductionMode
	
	effective_theory_flag=effective_theory_flag_in
	K_ewk=K_ewk_in
	K_ewk_real=K_ewk_real_in
	K_ewk_real_b=K_ewk_real_b_in
	ProductionMode=ProductionMode_in
	end
c====================================================
	subroutine set_quark_data(number_of_quarks_input,quarkdata)
	implicit none

      integer number_of_quarks_input,i,iix
	double precision quarkdata(0:299)
	!
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks   
      integer  number_of_quarks
	!
	double precision cutoff,delta,Gamma_q
	! original_masses : necessary for evolution at different orders
	double precision original_masses(100)
	common /OriginalMasses/ original_masses
	
	
	cutoff=1e-3
	
c      constructing (common blocked) quark_list 
c      used in sborn_mass @ ggxsections.F
c      number_of_quarks = 4 ! this is now a runcard argument
	number_of_quarks = number_of_quarks_input
	do i=1,number_of_quarks
		double_mq(i) = quarkdata(3*(i-1))
		original_masses(i)=double_mq(i)
		Gamma_q = quarkdata(3*(i-1)+1)
		Yq(i)=quarkdata(3*(i-1)+2)        
		if (abs(Gamma_q/double_mq(i)).gt.cutoff) then 
			Mq_square_complex(i) = double_mq(i)*
     $						dcmplx(double_mq(i),-Gamma_q)
		else
			delta =  1d-16
			Mq_square_complex(i) = dcmplx(double_mq(i)**2,-delta)            
		endif
	enddo
	
	end
c====================================================
	subroutine set_constants()
	implicit none
	double precision pi,z2,z3
      common /consts/ pi, z2, z3
	double precision Gf
	common /comGf/ Gf
	!----- constants
	pi=3.1415926535897D0
      z2=pi**2/6.0D0
      z3=1.2020569031595942854D0
	Gf = 1.16637d-5
	end
c====================================================
	subroutine set_hdecay_params(VBdata,quarkdata,DecayMode_input)
	implicit none
	double precision quarkdata(0:299),VBdata(0:299)

	! hdecay parameters
	double precision  mW_hdecay, mZ_hdecay,mtop_hdecay
      double precision  GammaW_hdecay, GammaZ_hdecay
	double precision Gf_HDECAY,mbot_HDECAY
	integer DecayMode_input
      double precision hdecay_asZnnlo
      common /hdecayparams/ hdecay_asZnnlo,mW_hdecay,
     $                  GammaW_hdecay,mZ_hdecay,GammaZ_hdecay,
     $                  mtop_hdecay,mbot_HDECAY,Gf_HDECAY 
      !
	double precision Gf
	common /comGf/ Gf
	!
      !
      integer DecayMode
      common /decaymodecom/ DecayMode
c--------------------------------------- start of HDECAY related arguments      
      DecayMode = DecayMode_input

      !: a_s(mZ) that is used in  hdecay  
      hdecay_asZnnlo = 0.11707D0
	! explicit masses and widths are only used in Hdecay (passed to it by common block)
	! default values can be found at ihiggs.cpp
	mW_hdecay = VBdata(0)
	GammaW_hdecay = VBdata(1)
	!Y_W = VBdata(2)
	mZ_hdecay = VBdata(4)
	GammaZ_hdecay = VBdata(5)
	!Y_Z = VBdata(5)
	mtop_hdecay = quarkdata(0)
	
	!porder_for_b_evolution = 'NNLO'
	!: mbot_HDECAY = Yukawa_bot/sqrt(Gf*sqrt(2)) with 
	!: Yukawa_bot = Yukawa_bot @ Q_bot evolved 
	!: to mur through NNLO using hdecay_asNNLO 
c      mbot_HDECAY = yukawa_b(mur,porder_for_b_evolution,
c     $				Q_bot,
c     $				lambdab0,
c     $				active_flavours,hdecay_asZnnlo
c     $				)
c     $                  /sqrt(sqrt(2d0)*Gf)
	mbot_HDECAY = 4.68d0 ! this is supposed to be the pole mass at NLO	
	Gf_HDECAY =  Gf
	

	end
c====================================================

	subroutine set_pdfset_and_provider(i_pdf_provider,
     $					no_error_flag_in)
	implicit none
	!: pdf initialization variables
	character*40  pdfset_name(0:2)
	character*10 pdf_provider
	integer i_pdf_provider,p_min_order,no_error_flag
	integer no_error_flag_in
	common /comPDFsetup/ p_min_order,no_error_flag,
     $pdfset_name,pdf_provider
	
	no_error_flag=no_error_flag_in
	p_min_order=0
	
	select case(i_pdf_provider)
		case(1)
			pdf_provider = "MSTW"
		case(2)
			pdf_provider = "GJR"
		case(3)
			pdf_provider = "ABKM"
		case(4)
			pdf_provider = "MSTW_P"
		case(5)
			pdf_provider = "MSTW_M"
		case(6)
			pdf_provider = "MSTW90"
		case(7)
			pdf_provider = "MSTW90_P"
		case(8)
			pdf_provider = "MSTW90_M"
		case default
            print*,"NON RECOGNIZED PDF PROVIDER : ",i_pdf_provider
       end select

	
	if (pdf_provider.eq.'MSTW') then
        pdfset_name(0) = 'MSTW2008lo68cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo68cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo68cl.LHgrid'
      else if (pdf_provider.eq.'MSTW_P')then
        pdfset_name(0) = 'MSTW2008lo68cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo68cl_asmz+68cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo68cl_asmz+68cl.LHgrid'
        pdf_provider='MSTW'
      else if (pdf_provider.eq.'MSTW_M')then
        pdfset_name(0) = 'MSTW2008lo68cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo68cl_asmz-68cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo68cl_asmz-68cl.LHgrid'
        pdf_provider='MSTW'
      else if (pdf_provider.eq.'MSTW90')then
        pdfset_name(0) = 'MSTW2008lo90cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo90cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo90cl.LHgrid'
        pdf_provider='MSTW'
      else if (pdf_provider.eq.'MSTW90_P')then
        pdfset_name(0) = 'MSTW2008lo90cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo90cl_asmz+90cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo90cl_asmz+90cl.LHgrid'
        pdf_provider='MSTW'
      else if (pdf_provider.eq.'MSTW90_M')then
        pdfset_name(0) = 'MSTW2008lo90cl.LHgrid'
        pdfset_name(1) = 'MSTW2008nlo90cl_asmz-90cl.LHgrid'
        pdfset_name(2) = 'MSTW2008nnlo90cl_asmz-90cl.LHgrid'
        pdf_provider='MSTW'
      elseif (pdf_provider.eq.'ABKM') then
       ! pdfset_name(0) = 'a02m_lo.LHgrid'
        pdfset_name(0) = 'MSTW2008lo90cl.LHgrid'
        pdfset_name(1) = 'abkm09_5_nlo.LHgrid'
        pdfset_name(2) = 'abkm09_5_nnlo.LHgrid'
	  p_min_order=1
      elseif (pdf_provider.eq.'GJR') then
        pdfset_name(0) = 'GJR08lo.LHgrid'
        pdfset_name(1) = 'GJR08VFnloE.LHgrid'
        pdfset_name(2) = 'JR09VFnnloE.LHgrid'
      else
        print*,"[main] ERROR: unrecognized pdf_provider "
        stop
      endif
	end 



