c=============================================================================
c     Initializes a single pdf!
c=============================================================================
      subroutine init_pdf(name,muf)
      implicit none
      include 'pdf.h'
      character*40 name
      DOUBLEPRECISION muf
      character*40 PDFNAME(1) 
      DOUBLEPRECISION amz(1)
	integer no_error_flag
      PDFNAME(1)=NAME
      call PDF_FITTER(1,PDFNAME,NP,0,XMIN,muf,C,amz,no_error_flag)
      aqmz=amz(1)
      write(6,*)
      write(6,*)'..Initialised single PDF Set'
      write(6,*)
      end subroutine

c=============================================================================
c     Initialization of all pdfs
c=============================================================================
      subroutine init_pdfaserror(loc_name,muf,no_error_flag,Ngrids)
      implicit none
      include 'pdf_eigen_alpha.h'
      character*40 name(apdfnum)
	character*40 loc_name
      DOUBLEPRECISION muf
	integer no_error_flag,Ngrids
	
	name(1)=loc_name
      write(6,*)
      !print*,'Initialising    ',apdfnum ,' PDF sets'
      print*,'PDF set : ',loc_name
      write(6,*)
      
	
	
	
	
      call PDF_FITTER(APDFNUM,NAME,NP,NPDF,XMIN,muf,C,
     #			aqmz,no_error_flag,Ngrids)    
     	
      end subroutine

c---------------------------------------------------------------------
c     SUbroutines which return the C-coefs and the a(mz) values
c---------------------------------------------------------------------
      subroutine multiAMZ(amz)
      IMPLICIT NONE
      include 'pdf_eigen_alpha.h'
      doubleprecision amz(apdfnum)
      integer i
      do i=1,apdfnum
         amz(i)=aqmz(i)
      end do
      end subroutine
c----------------------------------------------------------------------------
      subroutine singleAMZ(amz)
      IMPLICIT NONE
      include 'pdf.h'
      doubleprecision amz
      AMZ=AQMZ
      end subroutine

c------------------------------------------------------------------------------
c     THE FOLLOWING FUNCTION WILL FIT A ALL THE PDFS AND RETURN COEFFICIENTS OF
C     THE PDF EFFECTIVE QUADRATICS 
c------------------------------------------------------------------------------
      SUBROUTINE PDF_FITTER(APDFNUM,NAM,NP,NPDF,XMIN,Q,CN,aqmz,
     #						no_error_flag,Ngrids)
      IMPLICIT NONE
C     OUTSIDE VARIABLES:
      INTEGER APDFNUM,no_error_flag
      CHARACTER*40 NAM(apdfnum)
      INTEGER ISET,NP,NPDF,Ngrids
      DOUBLEPRECISION XMIN,CN(apdfnum,0:NPDF,3,NP,-5:5),C(3,NP,-5:5)
      DOUBLEPRECISION aqmz(apdfnum),Q
C     INTERNAL VARIABLES:
      INTEGER I,IPRTN,CC,AC,number_of_members
      DOUBLEPRECISION X(NP),F(-6:6),FF(NP,-5:5),TINY
      DOUBLEPRECISION ALPHASPDF,QMZ
      PARAMETER(TINY=10D-8)
      parameter(QMZ=91.18d0)
	!---------------------- common block for a_s @ mZ
	include 'alpha_yukawa.h'
	!----------------------
C     INITIALISE LHA PDF for every alpha and eigenvector:
      DO AC=1,APDFNUM
         call setlhaparm('SILENT')   ! ommit the description from output
         call InitPDFsetByName(NAM(AC))
         !print*,NAM(AC) ! print name of pdf file
         !call GetDesc() ! get description of pdf set
         aqmz(AC)=alphasPDF(QMZ)   
	   if (no_error_flag.eq.0) then !: PDF error ON
		call numberPDF(number_of_members)   ! sets NPDF for current set 
		Ngrids = number_of_members
	   elseif (no_error_flag.eq.1) then !: PDF error OFF
		number_of_members=0
	   else
         print*,"[PDF_FITTER] ERROR: no_error_flag = ",
     #	no_error_flag.eq.0,"allowed values are 0,1"
	   endif
	   
         print*,"Initializing ",number_of_members+1," grid members."
         DO ISET=0,number_of_members
            call InitPDF(ISET)
		! getting the value of alpha_s @ Mz from LHAPDF
		alphaMz(ISET) = alphasPDF(QMZ) 
            
c            write(*,"(A,I3,A,(1F8.4))"), " Member # ",
c     &                  ISET," : a(mZ)=",alphaMz(ISET)
		!print*,"member # ",ISET," : a(mZ)=",alphaMz(ISET)   
c     compute grid:
            do I=1,Np
               X(I) = XMIN + (1d0-XMIN)*I*(I-1d0)/Np/(Np-1d0)
               call evolvePDF(min(X(I),1d0-tiny),Q,F)
               do iprtn=-5,5
                  FF(I,iprtn)=F(iprtn)
               end do
            end do                     
c     fit grid:
            call GET_C(FF,X,Np,C)              
            DO CC=1,3
               DO I=1,NP
                  DO IPRTN=-5,5
                     CN(AC,ISET,CC,I,IPRTN)=C(CC,I,IPRTN)
                  END DO
               END DO
            END DO           
         END DO
      END DO
      END SUBROUTINE 


c----------------------------------------------------------------------------

      SUBROUTINE GET_C(F,X,N,C)
      IMPLICIT NONE
      INTEGER N
      DOUBLEPRECISION F(N,-5:5),X(N),C(3,N,-5:5)
      INTEGER I,I1,I2,I3,IPRTN
      DO IPRTN=-5,5
         do I=1,N 
            if (i.eq.1) then
               I1=I
               I2=I+1
               I3=I+3
            elseif (i.eq.N) then 
               I1=i-2
               I2=i-1
               I3=I
            else
               i1=i-1
               i2=i
               i3=i+1
            endif 
            CALL pdf_give_coeff(X(I1)       ,X(I2)       ,X(I3)
     &                    ,F(I1,IPRTN) ,F(I2,IPRTN) ,F(I3,IPRTN)
     &                    ,c(1,I,IPRTN),C(2,I,IPRTN),C(3,I,IPRTN) )
         END DO
      END DO
      END SUBROUTINE

c-----------------------------------------------------------------

      subroutine pdf_give_coeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
      implicit double precision (a-h,o-z)    
      den=(xa1-xa2)*(xa2-xa3)*(xa3-xa1)
      a = -ya1*(xa2-xa3)/den
      a = a-ya2*(xa3-xa1)/den
      a = a-ya3*(xa1-xa2)/den
      b =  ya1*(xa2*xa2-xa3*xa3)/den
      b = b+ya2*(xa3*xa3-xa1*xa1)/den
      b = b+ya3*(xa1*xa1-xa2*xa2)/den
      c = -ya1*(xa2-xa3)*xa2*xa3/den
      c = c-ya2*(xa3-xa1)*xa1*xa3/den
      c = c-ya3*(xa1-xa2)*xa1*xa2/den
      return
      end 

c------------------------------------------------------------------
C     CALLS A PDF
C------------------------------------------------------------------
c      SUBROUTINE LHPDF_fit(APDFNUM,Np,NPDF,C,X,XMIN,F)
c      IMPLICIT NONE
c      INTEGER Np,NPDF,apdfnum
c      DOUBLEPRECISION C(APDFNUM,0:NPDF,3,Np,-5:5)
c      DOUBLEPRECISION X,XMIN,F(APDFNUM,0:NPDF,-5:5)
c      INTEGER IPRTN,L,AC,ISET
c      DOUBLEPRECISION HH,lambda,rr           
c      hh = Np*(Np-1)/(1D0-XMIN)
c      lambda = (x-XMIN)*hh
c      if(lambda.lt.0d0) then
c         write(6,*) 'WARNING: x out of fitting range'
c         lambda=0d0
c      endif
c      rr = 0.5d0*(1.0d0+dsqrt(1+4.d0*lambda))
c      L =int(rr) 
c      DO AC=1,APDFNUM
c         DO ISET=0,NPDF
c            DO IPRTN=-5,5
c               F(AC,iset,IPRTN) = (C(AC,iset,3,L,IPRTN)
c     &                           +C(AC,iset,2,L,IPRTN)*X
c     &                           +C(AC,iset,1,L,IPRTN)*X**2)/X
c            END DO
c         END DO
c      END DO
c      END SUBROUTINE
c
c--------------------------------------------------------------------
C     CALLS THE LUMINOSITY
C--------------------------------------------------------------------
c      SUBROUTINE LHLUMI_FIT(APDFNUM,Np,NPDF,C,X1,X2,XMIN,LUMI)
c      IMPLICIT NONE
c
c      INTEGER Np,NPDF,apdfnum
c      DOUBLEPRECISION C(APDFNUM,0:NPDF,3,Np,-5:5)
c      DOUBLEPRECISION F1(APDFNUM,0:NPDF,-5:5),F2(APDFNUM,0:NPDF,-5:5)
c      DOUBLEPRECISION X1,X2,XMIN,LUMI(APDFNUM,0:NPDF,-5:5,-5:5)
c
c      INTEGER I1,I2,AC,ISET
c      
c      CALL LHPDF_fit(APDFNUM,Np,NPDF,C,X1,XMIN,F1)
c      CALL LHPDF_fit(APDFNUM,Np,NPDF,C,X2,XMIN,F2)
c
c      DO AC=1,APDFNUM
c         DO ISET=0,NPDF
c            DO I1=-5,5
c               DO I2=-5,5
c                  LUMI(AC,iset,I1,I2)=F1(AC,iset,I1)*F2(AC,iset,I2)
c               END DO
c            END DO
c         END DO
c      END DO
c
c      END SUBROUTINE

C----------------------------------------------------------------------------
C     GIVEN THE INITIALISATION HAS TAKEN PLACE,THE FOLLOWING ROUTINES COMPUTE 
C     THE lUMINOSITY USING THE INITIALISED PARAMETERS
C----------------------------------------------------------------------------
c      SUBROUTINE MULTI_LUMI(X1,X2,L)
c      IMPLICIT NONE
c      include 'pdf_eigen_alpha.h'
c      DOUBLEPRECISION L(APDFNUM,0:NPDF,-5:5,-5:5),x1,x2
c     
c      call LHLUMI_FIT(APDFNUM,Np,NPDF,C,X1,X2,XMIN,L)
c
c      END SUBROUTINE

C---------------------------------------------------------------
C     AND FOR A SINGLE PDF:

c      SUBROUTINE SINGLE_LUMI(X1,X2,L)
c      IMPLICIT NONE
c      include 'pdf.h'
c      DOUBLEPRECISION LUMI(1,0:0,-5:5,-5:5),L(-5:5,-5:5),x1,x2
c      integer i1,i2
c      
c      call LHLUMI_FIT(1,Np,0,C,X1,X2,XMIN,LUMI)
c      
c      DO I1=-5,5
c         DO I2=-5,5
c            L(I1,I2)=LUMI(1,0,I1,I2)
c         END DO
c      END DO
c
c      END SUBROUTINE

c---------------------------------------------------------------------------
c     Calls the Luminosity using the LHAPDf routines:
c------------------------------------------------------------------------------
c      subroutine Lumi_ij(x1,x2,iset,Q,L_ij)
c      implicit none    
c      doubleprecision x1,x2,Q,L_ij(-5:5,-5:5)
c      integer iset,i1,i2
c      doubleprecision f1(-6:6),f2(-6:6)
c      
c      call InitPDF(iset)
c      call evolvePDF(x1,Q,f1)
c      call evolvePDF(x2,Q,f2)
c      do i1=-5,5
c         do i2=-5,5     
c            L_ij(i1,i2)=f1(i1)*f2(i2)/x1/x2      
c         end do
c      end do
c
c      end subroutine






CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Writes results for pdf+alpha_S errors:
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  

      subroutine ending_pdferror(integral_t,error_t,prob_t,size)
      implicit none
 
      include 'pdf_eigen_alpha.h'

      integer size
      doubleprecision integral_t(size),error_t(size),prob_t(size)

      character*133 fout
      double precision sig,dsig,chi2
      doubleprecision DPLUS,DMINUS,DINTEGRAL,dumint(NPDF+1)
      DOUBLEPRECISION PLUS,MINUS,CINTEGRAL
      INTEGER I,J

CCC   Compute PDF error(s) FOR EACH ALPHA AND FIND THE MAX OF THEM
      CINTEGRAL=INTEGRAL_t(1)

      PLUS=CINTEGRAL
      MINUS=CINTEGRAL

      DO I=1,APDFNUM      
         DO J=1,NPDF+1            
            DUMINT(J)=INTEGRAL_t((I-1)*(NPDF+1)+J)
         END DO
         
         DINTEGRAL=DUMINT(1)
         CALL eigenpdferror(NPDF+1, DUMINT, DPLUS, DMINUS)
         
         PLUS =MAX(DPLUS +DINTEGRAL ,PLUS)
         MINUS=MIN(DINTEGRAL-DMINUS,MINUS)

         write(6,*)
         write(6,*)I
         write(6,*)'pdf+',DPLUS +DINTEGRAL-CINTEGRAL
         write(6,*)'pdf-',CINTEGRAL-(DINTEGRAL-DMINUS)
      END DO
      

CCC   Add Prefix for output file depending on order of results
      fout='result.txt'
      call unlink(fout)
      open(21,FILE=fout,STATUS='NEW')
      write(21,*) '--------------  RESULTS  --------------'   
         
      sig=integral_t(1)
      dsig=error_t(1)
      chi2=prob_t(1)
     
      write(21,104) 'Sigma (pb)                  = ',sig
      write(21,104) 'MC Error (pb)               = ',dsig
      write(21,104) 'PDF+as Error + (pb)            = ',PLUS-CINTEGRAL
      write(21,104) 'PDF+as Error - (pb)            = ',CINTEGRAL-MINUS
      write(21,104) 'chi^2 Probability           = ',chi2        
      
      write(21,*) '--------------------------------'         
      close(21)

c 100  format(F7.3, G17.8, G17.8, F10.2)
c 101  format(F7.3, G17.8, G17.8)
c 102  format('  ----   ',A15,'   ----')
c 103  format(A30,F17.2)
 104  format(A30,G17.6)
      return
      END

c==================================================================
c     Babis routine to compute pdf errors:
c==================================================================
       subroutine eigenpdferror(Nmax, ris, pluse, minuse)
       implicit none
       integer Nmax, jj, jplus, jminus
       double precision ris(1:Nmax)
       double precision cval, pluse, minuse, esymm
       double precision tmp, tmp1, tmp2

       cval=ris(1)
       pluse=0d0
       minuse=0d0

       esymm = 0d0
       do jj=1,Nmax/2
          jplus = 2*jj
          jminus = 2*jj+1
          
          tmp1 = ris(jplus) - cval
          tmp2 = ris(jminus) - cval
          if (tmp1.gt.tmp2) then
             tmp = tmp1
          else
             tmp = tmp2
          endif
          if (tmp.lt.0d0) then
             tmp = 0d0
          endif
          pluse = pluse + tmp**2

          tmp1 = - tmp1
          tmp2 = - tmp2
          if (tmp1.gt.tmp2) then
             tmp = tmp1
          else
             tmp = tmp2
          endif
          if (tmp.lt.0d0) then
             tmp = 0d0
          endif

          minuse = minuse + tmp**2
          esymm = esymm + (tmp1-tmp2)**2

       enddo

       esymm = dsqrt(esymm)/cval*100d0/2d0

       pluse=dsqrt(pluse)
       minuse=dsqrt(minuse)
C----  for symmetric  error uncomment here
C      pluse = esymm
C      minuse = esymm

       end
